/**
   The prettyPrint() method takes a BTree and
   converts it into a well formatted string.
*/

public class PrettyPrinter
{
   public static String prettyPrint(BTree tree)
   {
      return prettyPrint(tree, "");
   }

   /**
      This prettyPrint() method is essentially
      a pre-order traversal of the tree.
   */
   private static String prettyPrint(BTree tree, String indentation)
   {
      String result = indentation;

      if (null == tree)  // empty tree stops the recursion
      {
         result += "()";
      }
      else if (tree.depth() == 0)  // depth==0 stops the recursion also
      {
         result += tree.getElement();
      }
      else
      {
         result += "(" + tree.getElement() + "\n";
         result += prettyPrint( tree.getLeftTree(),  indentation+"  " ) + "\n";
         result += prettyPrint( tree.getRightTree(), indentation+"  " ) + "\n";
         result += indentation + ")";
      }

      return result;
   }
}
